/*********************************
 RawVF click processor
 adds missing info to RawVF files
 WARNING! The following code
 is *much* more awful than you
 may expect.
*********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define MAXLEN 1000
#define MAXOPS 1000
#define MAXISLS 1000

int no_board_events=0,no_zini=0,no_rilian_clicks=1,no_check_info=0;

FILE* input;
FILE* output;
int w,h,m,size;
int won=0;
struct cell
{
	int mine;
	int opening; /* 0 iff cell is non-opening 3bv */
	int opening2;	/* one cell may belong to 2 openings */
	int island;
	int number;
	int rb,re,cb,ce; /* these things are there to determine cell neighbours */
	int opened;
	int flagged,wasted_flag;
	int questioned;
	int premium;
};
typedef struct cell cell;
cell* board;

int bbbv,openings,islands,zini,gzini,hzini;
int l_clicks,r_clicks,d_clicks,clicks_15;
int wasted_l_clicks,wasted_r_clicks,wasted_d_clicks,wasted_clicks_15;
int rilian_clicks;
int flags,wasted_flags,unflags,misflags,misunflags;
int distance;
int solved_bbbv;
int closed_cells;
int size_ops[MAXOPS];
int size_isls[MAXISLS];
int solved_ops,solved_isls;

/* mouse state */
int left,right,middle,shift_left;
int chorded,onedotfive;
int cur_x,cur_y,cur_prec_x,cur_prec_y;

int cur_time,end_time=0;

char event[MAXLEN];

/* gameplay settings */
int qm,elmar,nono,superclick,superflag;

void pause()
{
	fprintf(stderr,"Press enter to exit\n");
	while(getchar()!='\n');
}

void error(const char* msg)
{
	fprintf(stderr,"%s\n",msg);
/*	pause();*/
	exit(1);
}

int opteq(const char* opt,const char* str)
{
	int i=0;
	while(opt[i]!=':' && opt[i]!=' ' && opt[i] && str[i] && tolower(opt[i])==tolower(str[i])) ++i;
	return opt[i]==':' && str[i]==0;
}
int valeq(const char *val, const char* str)
{
	int i=0;
	while(val[i++]==' ');
	while(str[i] && val[i]!='\n' && val[i]!=' ' && val[i] && tolower(str[i])==tolower(val[i])) ++i;
	return (val[i]=='\n' || val[i]==' ') && str[i]==0;
}

void clearboard()
{
	int i;
	closed_cells=size;
	for(i=0;i<size;++i)
		board[i].mine=board[i].opened=board[i].flagged=board[i].questioned=board[i].wasted_flag=
		board[i].opening=board[i].opening2=board[i].island=0;
}
void restartboard()
{
	int i;
	closed_cells=size;
	for(i=0;i<size;++i)
		board[i].opened=board[i].flagged=board[i].wasted_flag=board[i].questioned=0;
}
void set_opening_border(int op_id,int index)
{
	if(!board[index].opening)
		board[index].opening=op_id;
	else if(board[index].opening!=op_id)
		board[index].opening2=op_id;
}
void process_opening(int op_id,int index)
{
	int rr,cc;
	++size_ops[op_id];
	board[index].opening=op_id;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
		{
			int i=cc*h+rr;
			if(board[i].number && !board[i].mine)
			{
				if(board[i].opening!=op_id && board[i].opening2!=op_id) ++size_ops[op_id];
				set_opening_border(op_id,i);
			}
			else if(!board[i].opening && !board[i].mine)
				process_opening(op_id,i);
		}		
}
void process_island(int is_id,int index)
{
	int rr,cc;
	board[index].island=is_id;
	++size_isls[is_id];
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
		{
			int i=cc*h+rr;
			if(!board[i].island && !board[i].mine && !board[i].opening)
				process_island(is_id,i);
		}		
}
int getadj3bv(int index)
{
	int res=0;
	int rr,cc;
	if(!board[index].number) return 1;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
		{
			int i=cc*h+rr;
			res+=(!board[i].mine && !board[i].opening); 
		}
	if(board[index].opening) ++res;
	if(board[index].opening2) ++res;
	return res;
}
int getnumber(int index)
{
	int rr,cc;
	int res=0;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
			res+=board[cc*h+rr].mine;
	return res;
}
void open(int index)
{
	int rr,cc;
	board[index].opened=1;
	++board[index].premium;	/* it's now opened! */
	if(!board[index].opening) /* if it's a non-opening 3bv */
		for(rr=board[index].rb;rr<=board[index].re;++rr)
			for(cc=board[index].cb;cc<=board[index].ce;++cc)
				--board[cc*h+rr].premium; /* reduce premium of neighbours */
	--closed_cells;
}
void reveal(int index)
{
	if(board[index].opened) return;
	if(board[index].flagged) return;

	if(board[index].number)
		open(index);
	else /* damn it's an opening!!! */
	{
		int op=board[index].opening;
		int i;
		for(i=0;i<size;++i)
		{
			if(board[i].opening2==op ||
				board[i].opening==op)
			{
				if(!board[i].opened) open(i);
				--board[i].premium;	/* reduce adjacent 3bv, a nearby opening opened */
			}
		}
	}
}
void click(int index)
{
	reveal(index);
	++zini;
}
void hit_openings()
{
	int j;
	for(j=0;j<size;++j)
		if(!board[j].number && !board[j].opened)
		{
			click(j);
		}
}
void flag(int index)
{
	int rr,cc;
	if(board[index].flagged) return;
	++zini;
	board[index].flagged=1;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
			++board[cc*h+rr].premium; /* increase premium of neighbours */
}
void flagaround(int index)
{
	int rr,cc;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
		{
			int i=cc*h+rr;
			if(board[i].mine) flag(i);
		}
}
void chord(int index)
{
	int rr,cc;
	++zini;
	for(rr=board[index].rb;rr<=board[index].re;++rr)
		for(cc=board[index].cb;cc<=board[index].ce;++cc)
			reveal(cc*h+rr); /* open all neighbours */
}

void init_board()
{
	int i;
	int r,c;
	openings=0;
	for(r=0;r<h;++r)
	{
		for(c=0;c<w;++c)
		{
			int index=c*h+r;
			board[index].rb=r?r-1:r;
			board[index].re=r==h-1?r:r+1;
			board[index].cb=c?c-1:c;
			board[index].ce=c==w-1?c:c+1;
		}
	}
	/* initialize openings */
	for(i=0;i<size;++i)
	{
		board[i].premium=-(board[i].number=getnumber(i))-2;
	}
	for(i=0;i<size;++i)
		if(!board[i].number && !board[i].opening)
		{
			if(++openings>MAXOPS) error("Too many openings");
			size_ops[openings]=0;
			process_opening(openings,i);
		}
	for(i=0;i<size;++i)
		if(!board[i].opening && !board[i].island && !board[i].mine)
		{
			if(++islands>MAXISLS) error("Too many islands");
			size_isls[islands]=0;
			process_island(islands,i);
		}
}
void calc_bbbv()
{
	int i;
	bbbv=openings;
	for(i=0;i<size;++i)
	{
		if(!board[i].opening && !board[i].mine)	++bbbv;
		board[i].premium+=getadj3bv(i);
	}
}
void calc_zini()
{
	int i;
	/* calculating ZiNi */
	zini=0;
	restartboard();
	while(closed_cells>m)
	{
		int maxp=-1;
		int curi=-1;
		for(i=0;i<size;++i)
		{
			if(board[i].premium>maxp &&	!board[i].mine)
			{
				maxp=board[i].premium;
				curi=i;
			}
		}
		if(curi!=-1) /* there's a non-negative premium */	
		{	
			if(!board[curi].opened) click(curi);
			flagaround(curi);
			chord(curi);
		}
		else /* left-click */
		{
			for(i=0;i<size;++i)
				if(!board[i].opened && !board[i].mine &&
					(!board[i].number || !board[i].opening))
				{
					curi=i;
					break;
				}
			click(curi);
		}			
	}
	gzini=zini;
	/* calculating HZiNi */
	for(i=0;i<size;++i)
	{
		board[i].premium=-(board[i].number)-2+getadj3bv(i);;
	}
	zini=0;
	restartboard();
	hit_openings();
	while(closed_cells>m)
	{
		int maxp=-1;
		int curi=-1;
		for(i=0;i<size;++i)
		{
			if(board[i].premium>maxp &&	!board[i].mine && board[i].opened)
			{
				maxp=board[i].premium;
				curi=i;
			}
		}
		if(curi!=-1) /* there's a non-negative premium */	
		{	
			if(!board[curi].opened) click(curi);
			flagaround(curi);
			chord(curi);
		}
		else /* left-click */
		{
			for(i=0;i<size;++i)
				if(!board[i].opened && !board[i].mine &&
					(!board[i].number || !board[i].opening))
				{
					curi=i;
					break;
				}
			click(curi);
		}			
	}
	hzini=zini;
	restartboard();
}

int is_inside_board(int x,int y)
{
	return x>=0 && x<w && y>=0 && y<h;
}
void push(int x,int y)
{
	if(no_board_events) return;
	if(!board[x*h+y].opened && !board[x*h+y].flagged)
	{
		if(board[x*h+y].questioned)
			fprintf(output,"pressedqm %d %d\n",x+1,y+1);
		else
			fprintf(output,"pressed %d %d\n",x+1,y+1);
	}
}
void push_around(int x,int y)
{
	int i,j;
	for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
		for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
			push(j,i);
}
void pop(int x,int y)
{
	if(!board[x*h+y].opened && !board[x*h+y].flagged)
	{
		if(board[x*h+y].questioned)
			fprintf(output,"qm %d %d\n",x+1,y+1);
		else
			fprintf(output,"closed %d %d\n",x+1,y+1);
	}
}
void pop_around(int x,int y)
{
	int i,j;
	for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
		for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
			pop(j,i);
}
void win()
{
	end_time=cur_time;
	won=1;
}
void check_win()
{
//	fprintf(stderr,"%d : solved %d/%d\n",cur_time,solved_bbbv,bbbv);
	if(bbbv==solved_bbbv) win();
}
void fail()
{
	end_time=cur_time;
	won=0;
}
void show(int x,int y)
{
	int index=x*h+y;
	fprintf(output,"number%d %d %d\n",board[index].number,x,y);
	board[index].opened=1;
	if(board[index].opening) if(!(--size_ops[board[index].opening])) {++solved_ops;++solved_bbbv;}
	if(board[index].opening2) if(!(--size_ops[board[index].opening2])) {++solved_ops;++solved_bbbv;}
}
void show_opening(int op)
{
	int i,j,k=0;
	for(i=0;i<w;++i) for(j=0;j<h;++j,++k) 
		if(board[k].opening==op || board[k].opening2==op) 
			if(!board[k].opened && !board[k].flagged) 
				show(i,j);
}
void do_open(int x,int y)
{
	if(board[x*h+y].mine)
	{
		board[x*h+y].opened=1;
		fprintf(output,"blast %d %d\n",x+1,y+1); 
		fail();
	}
	else
	{
		if(!board[x*h+y].number) 
			show_opening(board[x*h+y].opening);
		else 
		{
			show(x,y);
			if(!board[x*h+y].opening) 
			{
				++solved_bbbv;
				if(!(--size_isls[board[x*h+y].island])) ++solved_isls;
				check_win();
			}
		}
/*		if(autoflag) apply_autoflag();*/
	}
}
int flags_around(int x,int y)
{
	int i,j,res=0;
	for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
		for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
			if(board[j*h+i].flagged) ++res;
	return res;
}
void do_chord(int x,int y,int onedotfive)
{
	int wasted=1,i,j;
	if(board[x*h+y].number==flags_around(x,y) && board[x*h+y].opened)
	{
		// the following check for {neighborhood} is done before opening to make solved3bv counter work right
		for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
			for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
				if(board[j*h+i].mine && !board[j*h+i].flagged)
					fail();
		for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
			for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
				if(!board[j*h+i].opened && !board[j*h+i].flagged)
				{
					do_open(j,i);
					wasted=0;
				}
				else if(board[j*h+i].flagged && board[j*h+i].wasted_flag)
				{
					board[j*h+i].wasted_flag=0;
					--wasted_flags;
				}
		if(wasted)
		{
			++wasted_d_clicks;
			if(onedotfive) ++wasted_clicks_15;
		}
	}
	else
	{
		pop_around(x,y);
		++wasted_d_clicks; 
		if(onedotfive) ++wasted_clicks_15;
	}
}
void do_set_flag(int x,int y)
{
	board[x*h+y].flagged=board[x*h+y].wasted_flag=1;
	fprintf(output,"flag %d %d\n",x+1,y+1);
	++flags;++wasted_flags;
	if(!board[x*h+y].mine) ++misflags;
}
void do_unset_flag(int x,int y)
{
	board[x*h+y].flagged=board[x*h+y].questioned=0;
	fprintf(output,"closed %d %d\n",x+1,y+1);
	--flags;++unflags;
	if(board[x*h+y].mine) ++misunflags;
}
void do_question(int x,int y)
{
	board[x*h+y].questioned=1;
	fprintf(output,"qm %d %d\n",x+1,y+1);
}
void do_flag_around(int x,int y)
{
	int i,j;
	for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
		for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
			if(!board[j*h+i].flagged && !board[j*h+i].opened)
				do_set_flag(j,i);
}
int closed_sq_around(int x,int y)
{
	int i,j,res=0;
	for(i=board[x*h+y].rb;i<=board[x*h+y].re;++i)
		for(j=board[x*h+y].cb;j<=board[x*h+y].ce;++j)
			if(!board[j*h+i].opened) ++res;
	return res;
}
void mouse_move(int x,int y,int prec_x,int prec_y);
void left_click(int x,int y,int prec_x,int prec_y)
{
	if(!left) return;
	if(x!=cur_x || y!=cur_y) mouse_move(x,y,prec_x,prec_y);
	left=0;
	if(!is_inside_board(x,y))
	{
		chorded=0;
		return;
	}
	if(right || shift_left || (superclick && board[x*h+y].opened))	// chord
	{
		++d_clicks;
		if(onedotfive) ++clicks_15;
		do_chord(x,y,onedotfive);
		chorded=right;
		shift_left=0;
	}
	else	// left click
	{
		if(chorded)	// rilian click
		{
			chorded=0;
			++rilian_clicks;
			if(no_rilian_clicks) return;
		}
		++l_clicks;
		if(!board[x*h+y].opened && !board[x*h+y].flagged) do_open(x,y); else ++wasted_l_clicks;
		chorded=0;
	}
	cur_x=x;cur_y=y;
}
void mouse_move(int x,int y,int prec_x,int prec_y)
{
	if(is_inside_board(x,y))
	{
		if((left && right) || middle || shift_left) 
		{
			if(cur_x!=x || cur_y!=y)
			{
				pop_around(cur_x,cur_y);
				push_around(x,y);
			}
		}
		else if(superclick && left && board[cur_x*h+cur_y].opened)
		{
			pop_around(cur_x,cur_y);
			if(board[x*h+y].opened)
				push_around(x,y);
			else 
				push(x,y);
		}
		else if(left && !chorded)
		{
			if(cur_x!=x || cur_y!=y)
			{
				pop(cur_x,cur_y);
				push(x,y);
			}
			if(nono && (cur_x!=x || cur_y!=y))
			{
				int sl=shift_left;
				left_click(x,y,cur_x,cur_y);
				left=1;
				shift_left=sl;
			}
		}
	}
	distance+=abs(cur_prec_x-prec_x)+abs(cur_prec_y-prec_y);	/* we use the manhattan metric */
	cur_prec_x=prec_x;cur_prec_y=prec_y;
	if(is_inside_board(x,y))
	{
		cur_x=x;cur_y=y;
	}
}
void left_press(int x,int y,int prec_x,int prec_y)
{
	if(middle) return;
	left=1;shift_left=0;
	if(!is_inside_board(x,y)) return;
	if(!right && !(superclick && board[x*h+y].opened))
		push(x,y);
	else
		push_around(x,y);
	if(elmar || nono)
	{
		left_click(x,y,prec_x,prec_y);
		left=1;
	}
	cur_x=x;cur_y=y;
}
void left_press_with_shift(int x,int y,int prec_x,int prec_y)
{
	if(middle) return;
	left=shift_left=1;
	if(!is_inside_board(x,y)) return;
	push_around(x,y);
	if(elmar || nono)
	{
		left_click(x,y,prec_x,prec_y);
		left=shift_left=1;
	}
	cur_x=x;cur_y=y;
}
void right_press(int x,int y,int prec_x,int prec_y)
{
	if(middle) return;
	right=1;shift_left=0;
	if(!is_inside_board(x,y)) return;
	if(left) 
		push_around(x,y);
	else
	{
		if(!board[x*h+y].opened)
		{
			onedotfive=1;chorded=0;
			if(board[x*h+y].flagged)
			{
				do_unset_flag(x,y);
				if(qm) do_question(x,y);
			}
			else
			{
				if(!qm || !board[x*h+y].questioned)
					do_set_flag(x,y);
				else
				{
					board[x*h+y].flagged=board[x*h+y].questioned=0;
					fprintf(output,"closed %d %d\n",x+1,y+1);
				}
			}
			++r_clicks;
		}
		else if(superflag && board[x*h+y].opened)
		{
			if(board[x*h+y].number && board[x*h+y].number>=closed_sq_around(x,y))
				do_flag_around(x,y);
		}
	}
	cur_x=x;cur_y=y;
}
void right_click(int x,int y,int prec_x,int prec_y)
{
	if(!right) return;
	right=shift_left=0;
	if(!is_inside_board(x,y))
	{
		chorded=left;
		onedotfive=0;
		return;
	}
	if(left)	// chord
	{
		pop_around(cur_x,cur_y);
		do_chord(x,y,0);
		++d_clicks;
		chorded=1;
	}
	else
	{
		if(!onedotfive && !chorded) 	/* it hasn't produced neither a flag, nor a chord */
		{
			++r_clicks;	// it was a right click after all, not a beginning of a chord
			++wasted_r_clicks;
		}
		chorded=0;
	}
	onedotfive=0;
	cur_x=x;cur_y=y;
}
void middle_press(int x,int y,int prec_x,int prec_y)
{
	shift_left=left=right=onedotfive=chorded=0;	/* the middle button resets everything */
	middle=1;
	if(!is_inside_board(x,y)) return;
	push_around(x,y);
}
void middle_click(int x,int y,int prec_x,int prec_y)
{
	if(!middle) return;
	middle=0;
	if(!is_inside_board(x,y)) return;
	do_chord(x,y,0);
	++d_clicks;
}

double strtodouble(const char* str)
{
	double res=0.0;
	int cur=-1,neg=0,len=strlen(str),hop=1;
	while(str[++cur]==' ');
	if(!str[cur]) return 0.0;
	if(str[cur]=='-') 
	{
		neg=1;
		++cur;
	}
	while(cur<len && isdigit(str[cur])) {res=res*10+str[cur++]-'0';}
	if(str[cur++]!='.') return res;
	while(cur<len && isdigit(str[cur])) 
	{
		res=res*10+str[cur++]-'0';	
		hop*=10;
	}
	if(neg) res=-res;
	return res/hop;
}

int main(int argc,char** argv)
{
	int i,r,c,opts,std=0;
	
	if(argc<2)
	{
		printf("Usage: rawvf2rawvf [-eirsz] [input] [output]\n");
		printf("Options:\n");
		printf(" e - do not rewrite board events\n");
		printf(" i - do not check info contained in the header\n");
		printf(" r - treat rilian clicks as left clicks\n");
		printf(" s - read from the standard input\n");
		printf(" z - do not calculate ZiNi\n");
		return 2;
	}
	
	no_board_events=0;
	no_zini=0;
	if((opts=(argv[1][0]=='-')))
	{
		const char* v=argv[1];
		while(*v)
		{
			if(*v=='e') no_board_events=1;
			else if(*v=='i') no_check_info=1;
			else if(*v=='z') no_zini=1;
			else if(*v=='r') no_rilian_clicks=0;
			else if(*v=='s') std=1;
			++v;
		}
	}
	if(std)
		input=stdin;
	else
	{
		input=fopen(argv[argc>=3+opts?argc-2:argc-1],"r");
		if(!input) 
		{
			fprintf(stderr,"Can't open input file %s\n",argv[argc>=3+opts?argc-2:argc-1]);
			return 3;
		}
	}
	if(argc>=3+opts)
	{
		output=fopen(argv[argc-1],"w+");
		if(!output) 
		{
			fprintf(stderr,"Can't open output file %s\n",argv[argc-1]);
			return 4;
		}
	}
	else output=stdout;
	
	qm=elmar=nono=superclick=superflag=0;
	
	const char* info[]={"Time","3BV","Solved3BV","3BV/s","ZiNi","ZiNi/s","HZiNi","HZiNi/s",
						"Clicks","Clicks/s",
						"LeftClicks","LeftClicks/s","RightClicks","RightClicks/s",
						"DoubleClicks","DoubleClicks/s","WastedClicks","WastedClicks/s",
						"WastedLeftClicks","WastedLeftClicks/s",
						"WastedRightClicks","WastedRightClicks/s","WastedDoubleClicks",
						"WastedDoubleClicks/s","1.5Clicks","1.5Clicks/s",
						"IOE","Correctness","Throughput","ZNE","ZNT","HZNE","HZNT",
						"Openings","Islands",
						"Flags","WastedFlags","Unflags","Misflags","Misunflags",
						"RilianClicks","RilianClicks/s"};
	const int num_info=sizeof(info)/sizeof(char*);
	int has_info[num_info];
	long ptr_info[num_info];
	int info_i[num_info];
	double info_d[num_info];
	int int_info[]={0,1,1,0,1,0,1,0,
							1,0,
							1,0,1,0,
							1,0,1,0,
							1,0,
							1,0,1,
							0,1,0,
							0,0,0,0,0,0,0,
							1,1,
							1,1,1,1,1,
							1,0};
	int zini_info[]={0,0,0,0,1,1,1,1,
							0,0,
							0,0,0,0,
							0,0,0,0,
							0,0,
							0,0,0,
							0,0,0,
							0,0,0,1,1,1,1,
							0,0,
							0,0,0,0,0,
							0,0};
	int check_info[num_info];
	if(sizeof(info)/sizeof(int)!=num_info) error("Program isn't written properly");
	int ww=8,hh=8,mm=10,m_cl=1,no_mode=1;
	int square_size=16;
	int claims_win=0;
	for(i=0;i<num_info;++i) has_info[i]=0;
	for(i=0;i<num_info;++i) check_info[i]=1&&(!zini_info[i] || !no_zini);
	for(i=0;i<MAXOPS;++i) size_ops[i]=0;
	for(i=0;i<MAXISLS;++i) size_isls[i]=0;

	// reading the header
	while(1)
	{
		int info_str=0;
		long ptr=ftell(input);
		fgets(event,MAXLEN,input);
		if(feof(input)) 
		{
			error("No board\n");
		}
		
		if(opteq(event,"board")) break;
		else if(opteq(event,"width")) w=atoi(event+6);
		else if(opteq(event,"height")) h=atoi(event+7);
		else if(opteq(event,"mines")) m=atoi(event+6);
		else if(opteq(event,"marks")) qm=valeq(event+6,"on\n");
		else if(opteq(event,"level"))
		{
			const char* e=event+6;
			if(valeq(e,"marathon"))
				error("This program doesn't support marathon RawVF");
			else if(valeq(e,"beginner"))
			{
				ww=hh=8;mm=10;
			}
			else if(valeq(e,"intermediate"))
			{
				ww=hh=16;mm=40;
			}
			else if(valeq(e,"expert"))
			{
				ww=30;hh=16;mm=99;
			}
		}
		else if(opteq(event,"mode"))
		{
			no_mode=0;
			m_cl=valeq(event+5,"classic");
		}
		else if(opteq(event,"squaresize"))
		{
			square_size=atoi(event+11);
		}
		else
			for(i=0;i<num_info;++i)
			{
				if(opteq(event,info[i]))
				{
					has_info[i]=1;
					ptr_info[i]=ptr+strlen(info[i])+1L;
					info_str=1;
					break;
				}
			}
		fputs(event,output);
	}
	// adding missing stuff to the header
	if(m_cl && (w!=ww || h!=hh || m!=mm)) error("Non-standard board in classic mode");
	if(no_mode) fputs("Mode: classic\n",output);
	for(i=0;i<num_info;++i)
		if(!has_info[i])
		{
			fputs(info[i],output);
			ptr_info[i]=ftell(output)+2L;	
			fputs(":           \n",output);
		}
	// reading the board
	board=(cell*)malloc(sizeof(cell)*(size=w*h));
	clearboard();
	for(r=0;r<h;++r)
	{
		fgets(event,MAXLEN,input);
		for(c=0;c<w;++c) board[c*h+r].mine=event[c]=='*';
		fputs(event,output);
	}
	// calculating 3bv, zini, # of openings&islands
	init_board();
	calc_bbbv();
	if(!no_zini) calc_zini();
	// reading the events
	solved_bbbv=distance=l_clicks=r_clicks=d_clicks=wasted_l_clicks=wasted_r_clicks=wasted_d_clicks=
	clicks_15=wasted_clicks_15=flags=wasted_flags=unflags=misflags=misunflags=rilian_clicks=0;
	left=right=middle=shift_left=chorded=onedotfive=0;
	while(1)
	{
		int board_event,len=strlen(event);
		fgets(event,MAXLEN,input);
		if(feof(input)) break;
		
		board_event=len<=2 || event[0]=='c' || event[0]=='f' || event[0]=='q' || event[0]=='p' || event[0]=='n';
		if(!no_board_events && board_event) continue;
		
		fputs(event,output);
		
		if(board_event) 
			continue;
		else if(event[0]=='s') /* start */
			continue;
		else if(event[0]=='w')	/* won */
			claims_win=1;
		else if(event[0]=='b' && event[1]=='o')	/* lost */
			continue;
		else if(event[0]=='o')	/* odd termination */
			continue;
		else if(event[0]=='e')	/* end of video */
			continue;
		else if(isdigit(event[0]) || event[0]=='-')	/* mouse event */
		{
			int i=(event[0]=='-'?1:0);
			void (*func)(int,int,int,int)=0;
			int x,y,neg_x,neg_y;
			
			/* getting the time */
			cur_time=0;
			while(event[i]!='.' && i<len) cur_time=cur_time*10+event[i++]-'0';
			cur_time=cur_time*1000+(event[i+1]-'0')*100+(event[i+2]-'0')*10;
			if(isdigit(event[i+3])) cur_time+=(event[i+3]-'0');
			while(event[++i]!=' ' && i<len);
			while(event[++i]==' ' && i<len);
			if(event[0]=='-') cur_time=0;
			
			/* getting the event type */
			if(i+1>=len) continue;
			if(event[i]=='l')
				if(event[i+1]=='r')
					func=left_click;
				else if(event[i+1]=='c')
					func=left_press;
				else
					error("Unknown event");
			else if(event[i]=='r')
				if(event[i+1]=='r')
					func=right_click;
				else if(event[i+1]=='c')
					func=right_press;
				else
					error("Unknown event");
			else if(event[i]=='m')
				if(event[i+1]=='v')
					func=mouse_move;
				else if(event[i+1]=='r')
					func=middle_click;
				else if(event[i+1]=='c')
					func=middle_press;
				else
					error("Unknown event");
			else if(event[i]=='u')
				if(event[i+1]=='n')
					error("This program doesn't support 'unblast' event");
				else
					error("Unknown event");
			else if(event[i]=='s')
				if(event[i+1]=='t') /* start */
					continue;
				else if(event[i+1]=='x' || event[i+1]=='y') /* scrolling */
					continue;
				else if(event[i+1]=='c')
					func=left_press_with_shift;
				else
					error("Unknown event");
			else if(event[i]=='w') /* win */
				claims_win=1;
			else if(event[i]=='o') /* odd */
				continue;
			else if(event[i]=='b') /* boom */
				continue;
			else
				error("Unknown event");

			while(event[++i]!='(' && i<len);
			while(!isdigit(event[++i]) && i<len);
			neg_x=event[i-1]=='-';
			x=0;
			while(isdigit(event[i]) && i<len) x=x*10+event[i++]-'0';
			while(!isdigit(event[++i]));
			if(neg_x) x=-x;
			neg_y=event[i-1]=='-';
			y=0;
			while(isdigit(event[i]) && i<len) y=y*10+event[i++]-'0';
			if(neg_y) y=-y;
				
			func(x/square_size,y/square_size,x,y);
		}
	}
	// writing info
	if(!end_time) end_time=cur_time;
	i=0;
	int clicks=l_clicks+r_clicks+d_clicks;
	int w_clicks=wasted_l_clicks+wasted_r_clicks+wasted_d_clicks;
	int e_clicks=clicks-w_clicks;
	double coeff=(double)solved_bbbv/bbbv;
	info_d[i++]=end_time/1000.0;
	info_i[i++]=bbbv;
	info_i[i++]=solved_bbbv;
	info_d[i++]=solved_bbbv/info_d[0];
	info_i[i++]=gzini;
	info_d[i++]=gzini*solved_bbbv/(bbbv*info_d[0]);
	info_i[i++]=hzini;
	info_d[i++]=hzini*solved_bbbv/(bbbv*info_d[0]);
	info_i[i++]=clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=l_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=r_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=d_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=w_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=wasted_l_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=wasted_r_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=wasted_d_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_i[i++]=clicks_15;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	info_d[i++]=(double)solved_bbbv/clicks;
	info_d[i++]=(e_clicks)/(double)clicks;
	info_d[i++]=(double)solved_bbbv/e_clicks;
	info_d[i++]=(double)gzini*coeff/clicks;
	info_d[i++]=(double)gzini*coeff/e_clicks;
	info_d[i++]=(double)hzini*coeff/clicks;
	info_d[i++]=(double)hzini*coeff/e_clicks;
	info_i[i++]=openings;
	info_i[i++]=islands;
	info_i[i++]=flags;
	info_i[i++]=wasted_flags;
	info_i[i++]=unflags;
	info_i[i++]=misflags;
	info_i[i++]=misunflags;
	info_i[i++]=rilian_clicks;
	info_d[i]=info_i[i-1]/info_d[0];++i;
	
	if(!no_check_info && claims_win && !won) 
		fprintf(stderr,"File contains wrong info: it says the game was won while it was not\n");
	for(i=0;i<num_info;++i)
		if(!check_info[i]) continue;
		else if(!has_info[i])
		{
			fseek(output,ptr_info[i],SEEK_SET);
			if(int_info[i])
				fprintf(output,"%d",info_i[i]);
			else
				fprintf(output,"%.3f",info_d[i]);
		}
		else if(!no_check_info)
		{
			int j;double d,dd;
			fseek(input,ptr_info[i],SEEK_SET);
			fgets(event,MAXLEN,input);
			if(int_info[i] && (j=atoi(event))!=info_i[i])
				fprintf(stderr,"File contains wrong info:\n %s = %d while the file claims it's %d\n",
						info[i],info_i[i],j);
			else if(!int_info[i] && (((dd=(d=strtodouble(event))-info_d[i]))>=0.001 || dd<=-0.001))
				fprintf(stderr,"File contains wrong info:\n %s = %.3f while the file claims it's %.3f\n",
						info[i],info_d[i],d);
		}
	
	free(board);
	return 0;
}

